#include "testlib.h"
#include <string>

using std::string;

int answ(InStream& stream, string &test) {
    string output = stream.readWord();
    if (output.length() != test.length())
        stream.quitf(_wa, "Length of output is %d, but length of test is %d", output.length(), test.length());

    int balance = 0, answer = 0;
    for (int i = 0; i < output.length(); ++i) {
        if (test[i] != '?' && output[i] != test[i])
            stream.quitf(_wa, "Output doesn't coincide with test");
        if (output[i] != '(' && output[i] != ')')
            stream.quitf(_wa, "Output contains forbidden symbol %c", output[i]);
        if (output[i] == '(') {
            balance++;
        }
        if (output[i] == ')' && balance > 0) {
            balance--;
            answer++;
        }
    }
    return answer;
}


int main(int argc, char **argv) {
    registerTestlibCmd(argc, argv);

    string test = inf.readWord();

    int output = answ(ouf, test);
    int answer = answ(ans, test);

    if (output > answer) {
        quitf(_fail, "Participant got %d, although judge got %d", output, answer);
    }
    if (output < answer) {
        quitf(_wa, "Expected %d, got %d", answer, output);
    }
    quitf(_ok, "Answer is %d", answer);

    return 0;
}
