#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>
#include "testlib.h"

using namespace std;

void gen(vector<char> &s, int left, int right) {
    if (left >= right)
        return;
    int len = (right - left + 1) / 2;
    int middle = left + rnd.next(1, len) * 2 - 1;
    s[left] = '(';
    s[middle] = ')';
    gen(s, left + 1, middle - 1);
    gen(s, middle + 1, right);
    return;
}

int main(int argc, char ** argv) {
	registerGen(argc, argv, 1);

	if (argc < 3) {
		cerr << "Usage: N, M - number of question mars" << endl;
		return 1;
	}

	int n = atoi(argv[1]);
	int m = atoi(argv[2]);

	if (n % 2) {
        cerr << "Error: N is odd" << endl;
		return 1;
	}

	if (m > n) {
        cerr << "Error: N < M" << endl;
		return 1;
	}

    vector<char> s(n), qm(n, '0');
    gen(s, 0, n - 1);
    for (int i = 0; i < m; ++i)
        qm[i] = '?';
    shuffle(qm.begin(), qm.end());

    for (int i = 0; i < n; i++)
        if (qm[i] == '?')
            printf("?");
        else
            printf("%c", s[i]);
    printf("\n");
    return 0;
}
