#include "testlib.h"
#include <iostream>
#include <vector>

#define len(a) ((int) (a).size())

using namespace std;

inline int gcd(int a, int b) {
    while (b) {
        int y = a % b;
        a = b;
        b = y;
    }
    return a;
}

inline pair<int, int> normalize(int a, int b) {
    if (a < 0 || (a == 0 && b < 0)) {
        a = -a, b = -b;
    }
    int g = gcd(abs(a), abs(b));
    a /= g, b /= g;
    return make_pair(a, b);
}

int main(int argc, char **argv) {
	registerGen(argc, argv, 1);
	int c1 = atoi(argv[1]), c2 = atoi(argv[2]), c3 = atoi(argv[3]), t = atoi(argv[4]);
	vector<tuple<int, int, int>> ans;
	set<pair<int, int>> st;
	for (int a = -c1; a <= c1; a++) {
		for (int b = -c2; b <= c2; b++) {
			if (a * a + b * b > 0 && !st.count(normalize(a, b))) {
				ans.emplace_back(a, b, rnd.next(-c3, c3));
				st.insert(normalize(a, b));
			}
		}
	}
	cout << len(ans) << " " << t << endl;
	for (auto i : ans) {
		int a, b, c; tie(a, b, c) = i;
		printf("%d %d %d\n", a, b, c);
	}
	for (int i = 0; i < t; i++) {
		printf("%d %d %d\n", rnd.next(-10000, 10000), rnd.next(-10000, 10000), rnd.next(-10000, 10000));
	}
	return 0;
}