#include "testlib.h"
#include <iostream>

using namespace std;

void genLine(int &a, int &b, int &c, int C) {
	int x1 = 0, y1 = 0, x2 = 0, y2 = 0;
	while (x1 == x2 && y1 == y2) {
		x1 = rnd.next(-C, C);
		y1 = rnd.next(-C, C);
		x2 = rnd.next(-C, C);
		y2 = rnd.next(-C, C);
	}
	a = y2 - y1;
	b = x1 - x2;
	c = -(a * x1 + b * y1);
}

inline int gcd(int a, int b) {
    while (b) {
        int y = a % b;
        a = b;
        b = y;
    }
    return a;
}

inline pair<int, int> normalize(int a, int b) {
    if (a < 0 || (a == 0 && b < 0)) {
        a = -a, b = -b;
    }
    int g = gcd(abs(a), abs(b));
    a /= g, b /= g;
    return make_pair(a, b);
}

int main(int argc, char **argv) {
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]), t = atoi(argv[2]), C = atoi(argv[3]);
	cout << n << " " << t << endl;
	set<pair<int, int>> st;
	st.insert(normalize(atoi(argv[4]), atoi(argv[5])));
	for (int i = 0; i < n; i++) {
		int a, b, c; genLine(a, b, c, C);
		while (st.count(normalize(a, b))) {
		    genLine(a, b, c, C);
		}
		st.insert(normalize(a, b));
		printf("%d %d %d\n", a, b, c); 
	}	
	for (int i = 0; i < t; i++) {
		printf("%d %d %d\n", atoi(argv[4]), atoi(argv[5]), rnd.next(-C, C));
	}
	return 0;
}