#include "testlib.h"
#include <vector>
#include <iostream>

#define mp make_pair

using namespace std;

int gcd(int a, int b) {
	while (b) {
		int y = a % b;
		a = b, b = y;
	}
	return a;
}

pair<int, int> norm(int a, int b) {
	if (a < 0 || (a == 0 && b < 0)) {
		a = -a, b = -b;
	}
	int g = gcd(a, b);
	a /= g, b /= g;
	return mp(a, b);
}

int main(int argc, char **argv) {
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]), t = atoi(argv[2]);
	cout << n << " " << t << endl;
	int x = rnd.next(-10000, 10000), y = rnd.next(-10000, 10000);
	for (int i = 0; i < n; i++) {
		int a = rnd.next(-10000, 10000), b = rnd.next(-10000, 10000);
		static set<pair<int, int>> st;
		while (st.count(norm(a, b)) || abs(a * x + b * y) > 100000000) {
			a = rnd.next(-10000, 10000);
			b = rnd.next(-10000, 10000);
		}
		st.insert(norm(a, b));
		printf("%d %d %d\n", a, b, -(a * x + b * y));
	}
	for (int i = 0; i < t; i++) {
		printf("%d %d %d\n", rnd.next(-10000, 10000), rnd.next(-10000, 10000), rnd.next(-100000000, 100000000));
	}
	return 0;
}