#include "testlib.h"
#include <vector>
#include <iostream>
#include <cassert>

typedef long long int64;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)

using namespace std;

inline int gcd(int a, int b) {
    while (b) {
        int y = a % b;
        a = b;
        b = y;
    }
    return a;
}

inline pair<int, int> normalize(int a, int b) {
    if (a < 0 || (a == 0 && b < 0)) {
        a = -a, b = -b;
    }
    int g = gcd(abs(a), abs(b));
    a /= g, b /= g;
    return make_pair(a, b);
}

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);
	int n = atoi(argv[1]), c = atoi(argv[2]), t = atoi(argv[3]);
	cout << n << " " << t << endl;
	set<pair<int, int>> st;
	for (int i = 0; i < t; i++) {
	    st.insert(normalize(i, 1));
	}
	st.insert(normalize(0, 1));
	for (int i = 0; i < c; i++) {
		int a1 = rnd.next(9000, 10000), a2 = 1;
		int b1 = rnd.next(-10000, 10000), b2 = rnd.next(9000, 10000);
		int c2 = rnd.next(-10000, 10000), c1 = a1 * c2 - 1;
		int d = a1 * b2 - a2 * b1;
		assert(d != 0);
		if (st.count(normalize(a1, b1)) || st.count(normalize(a2, b2))) {
		    i--;
		    continue;
		}
		st.insert(normalize(a1, b1));
		st.insert(normalize(a2, b2));
		printf("%d %d %d\n%d %d %d\n", a1, b1, -c1, a2, b2, -c2);
		int64 dx = 1ll * c1 * b2 - 1ll * c2 * b1, dy = 1ll * a1 * c2 - 1ll * a2 * c1;
		eprintf("d = %d; dx = %lld; dy = %lld\n", d, dx, dy);
		int64 x = 1.0 * dx / d, y = 1.0 * dy / d;
		assert(-10000 <= x && x <= 10000);
		assert(-10000 <= y && y <= 10000);
		eprintf("%.15lf, %.15lf\n", 1.0 * dx / d, 1.0 * dy / d);
	}
	for (int i = c * 2; i < n; i++) {
		//printf("%d %d %d\n", 0, 1, -i);
		int a = rnd.next(-10000, 10000), b = rnd.next(-10000, 10000), c = rnd.next(0, 100000000);
		if (st.count(normalize(a, b))) {
		    i--;
		    continue;
		}
		st.insert(normalize(a, b));
		printf("%d %d %d\n", a, b, c);
	}
	for (int i = 0; i < t; i++) {
		printf("%d %d %d\n", i, 10000, -i);
	}
	return 0;
}