import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.io.IOException;
import java.io.Reader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
import java.io.Writer;
import java.io.OutputStreamWriter;
import java.io.BufferedReader;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        InputReader in = new InputReader(inputStream);
        OutputWriter out = new OutputWriter(outputStream);
        ClosestIntersetionPoint solver = new ClosestIntersetionPoint();
        solver.solve(1, in, out);
        out.close();
    }

    static class ClosestIntersetionPoint {
        public void solve(int testNumber, InputReader in, OutputWriter out) {
            int n = in.readInt(), t = in.readInt();
            int[] a = new int[n], b = new int[n], c = new int[n];
            for (int i = 0; i < n; i++) {
                a[i] = in.readInt();
                b[i] = in.readInt();
                c[i] = -in.readInt();
            }
            for (int i = 0; i < t; i++) {
                int u = in.readInt(), v = in.readInt(), w = -in.readInt();
                run(n, a, b, c, u, v, w, out);
            }
        }

        void intersect(long a1, long b1, long c1, long a2, long b2, long c2, double[] result) {
            long d = a1 * b2 - a2 * b1, dx = c1 * b2 - c2 * b1, dy = a1 * c2 - a2 * c1;
            result[0] = 1. * dx / d;
            result[1] = 1. * dy / d;
        }

        void run(int n, int[] a, int[] b, int[] c, int u, int v, int w, OutputWriter out) {
            boolean s = v == 0;
            Point[] intersections = new Point[n];
            final double[] pt = new double[]{0, 0};
            for (int i = 0; i < n; i++) {
                intersect(a[i], b[i], c[i], u, v, w, pt);
                intersections[i] = new Point(!s ? pt[0] : pt[1], i);
            }
            Arrays.sort(intersections);
            double ans = 1e200;
            for (int i = 0; i < n - 1; i++) {
                int i1 = intersections[i].index, i2 = intersections[i + 1].index;
                intersect(a[i1], b[i1], c[i1], a[i2], b[i2], c[i2], pt);
                ans = Math.min(ans, Math.abs(u * pt[0] + v * pt[1] - w));
            }
            ans /= Math.sqrt(u * u + v * v);
            out.printf("%.20f\n", ans);
        }

    }

    static class Point implements Comparable<Point> {
        public final double x;
        public final int index;

        public Point(double x, int index) {
            this.x = x;
            this.index = index;
        }


        public int compareTo(Point o) {
            int k = Double.compare(x, o.x);
            return k != 0 ? k : Integer.compare(index, o.index);
        }

    }

    static class OutputWriter {
        private PrintWriter writer;

        public OutputWriter(Writer writer) {
            this.writer = new PrintWriter(writer);
        }

        public OutputWriter(OutputStream stream) {
            this(new OutputStreamWriter(stream));
        }

        public void printf(String format, Object... args) {
            writer.printf(format, args);
        }

        void close() {
            writer.close();
        }

    }

    static class InputReader {
        private BufferedReader reader;
        private StringTokenizer tokenizer;

        public InputReader(Reader reader) {
            this.reader = new BufferedReader(reader);
        }

        public InputReader(InputStream stream) {
            this(new InputStreamReader(stream));
        }

        public String nextLine() {
            try {
                return reader.readLine();
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }

        public String readWord() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                tokenizer = new StringTokenizer(nextLine());
            }
            return tokenizer.nextToken();
        }

        public int readInt() {
            return Integer.parseInt(readWord());
        }

    }
}

