#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
using namespace std;

int n, m;

struct team
{
    int a, b;
};

bool cmp (const team &first, const team &second)
{
    return (first.a < second.a || first.a == second.a && first.b < second.b);
}

bool equal (const team &first, const team &second)
{
    return (first.a == second.a && first.b == second.b);
}

team next(team cur)
{
    team new_team;
    if (cur.b == m)
    {
        new_team.a = cur.a + 1;
        new_team.b = cur.a + 2;
    }
    else
    {
        new_team.a = cur.a;
        new_team.b = cur.b + 1;
    }
    return new_team;
}

int main(int argc, char * argv[])
{
    scanf("%d%d", &n, &m);
    if (m == 2)
    {
        printf("-1");
        return 0;
    }
    vector<team> teams;
    for (int i = 0; i < n; ++i)
    {
        int a, b;
        scanf("%d%d", &a, &b);
        team new_team;
        new_team.a = min(a, b);
        new_team.b = max(a, b);
        teams.push_back(new_team);
    }
    for (int i = 0; i < n; ++i)
    {
        for (int j = 1; j < n; ++j)
        {
            if (cmp(teams[j], teams[j - 1]))
            {
                team buf = teams[j];
                teams[j] = teams[j - 1];
                teams[j - 1] = buf;
            }
        }
    }
    vector<team> new_teams;
    for (int i = 1; i < n; ++i)
    {
        if (equal(teams[i - 1], teams[i]))
        {
            new_teams.push_back(teams[i]);
        }
    }
    vector<int> colors;
    for (int i = 0; i < new_teams.size(); ++i)
    {
        colors.push_back(new_teams[i].a);
        colors.push_back(new_teams[i].b);
    }
    for (int i = 0; i < colors.size(); ++i)
    {
        for (int j = 1; j < colors.size(); ++j)
        {
            if (colors[j] < colors[j - 1])
            {
                int buf;
                buf = colors[j - 1];
                colors[j - 1] = colors[j];
                colors[j] = buf;
            }
        }
    } 
    if (colors.size() == 0 || colors[0] != 1)
    {
        printf("1\n1");
        return 0;
    }
    
    for (int i = 1; i < colors.size(); ++i)
    {
        if (colors[i] != colors[i - 1] && colors[i] != colors[i - 1] + 1)
        {
            printf("1\n%d", colors[i - 1] + 1);
            return 0;
        }
    }

    if (colors[colors.size() - 1] != m)
    {
        printf("1\n%d", m);
        return 0;
    }


    if (new_teams.size() == 0 || !(new_teams[0].a == 1 && new_teams[0].b == 2))
    {
        printf("2\n%d %d", 1, 2);
        return 0;
    }

    for (int i = 1; i < new_teams.size(); ++i)
    {
        if (equal(new_teams[i - 1], new_teams[i]))
        {
            continue;
        }

        if (equal(new_teams[i], next(new_teams[i - 1])))
        {
            continue;
        }
        team ans = next(new_teams[i - 1]);
        printf("2\n%d %d", ans.b, ans.a);
        return 0;
    }
    team last;
    last.a = m - 1;
    last.b = m;
    if (! (equal(new_teams[new_teams.size() - 1], last)))
    {   
        printf("2\n%d %d", m, m - 1);
        return 0;
    }
    printf("3\n%d %d %d", m - 2, m - 1, m);
}

