#include <iostream>
#include "testlib.h"

using namespace std;

const int N_MIN = 1;
const int N_MAX = 200000;
const int M_MIN = 1;
const int M_MAX = 200000;

int x[N_MAX + 1];
int ai[M_MAX];
int aj[M_MAX];
int oi[M_MAX];
int oj[M_MAX];
int l[M_MAX];
int r[M_MAX];

int main(int argc, char **argv)
{
    registerTestlibCmd(argc, argv);

    int n = inf.readInt(N_MIN, N_MAX);
    for (int i = 1; i <= n; i++) x[i] = inf.readInt();
    int m = inf.readInt(M_MIN, M_MAX);
    for (int i = 0; i < m; i++) {
    	l[i] = inf.readInt(1, n);
    	r[i] = inf.readInt(1, n);
    }

    for (int i = 0; i < m; i++) {
    	ai[i] = ans.readInt(-1, n);
    	aj[i] = ans.readInt(-1, n);
    	if (!((ai[i] == -1 && aj[i] == -1) || (ai[i] >= 1 && aj[i] >= 1)))
    		quitf(_fail, "Jury's answer for the %d-th query is incorrect: x[%d] = %d .. x[%d] = %d", i + 1, ai[i], ai[i] >= 1 ? x[ai[i]] : -1, aj[i], aj[i] >= 1 ? x[aj[i]] : -1);
    	if (!(ai[i] == -1 && aj[i] == -1) && (ai[i] < l[i] || aj[i] > r[i] || ai[i] >= aj[i] || x[ai[i]] >= x[aj[i]]))
    		quitf(_fail, "Jury's answer for the %d-th query is incorrect: x[%d] = %d .. x[%d] = %d", i + 1, ai[i], ai[i] >= 1 ? x[ai[i]] : -1, aj[i], aj[i] >= 1 ? x[aj[i]] : -1);
    }

    bool iswa = false;
    bool incorrect = false;
    int numwa = 0;

    for (int i = 0; i < m; i++) {
    	oi[i] = ouf.readInt(-1, n);
    	oj[i] = ouf.readInt(-1, n);
    	if (!((oi[i] == -1 && oj[i] == -1) || (oi[i] >= 1 && oj[i] >= 1)) ||
    		(!(oi[i] == -1 && oj[i] == -1) && (oi[i] < l[i] || oj[i] > r[i] || oi[i] >= oj[i] || x[oi[i]] >= x[oj[i]]))) {
    		if (!iswa) {
    			iswa = true;
    			incorrect = true;
    			numwa = i;
    		}
    		continue;
    	}
    	if (aj[i] - ai[i] < oj[i] - oi[i]) quitf(_fail, "Participant's answer is better for the %d-th query: jury - |(%d)-(%d)|=%d < participant - |(%d)-(%d)|=%d", i + 1, ai[i], aj[i], aj[i] - ai[i], oi[i], oj[i], oj[i] - oi[i]);
    	if (aj[i] - ai[i] > oj[i] - oi[i]) {
    		if (!iswa) {
    			iswa = true;
    			incorrect = false;
    			numwa = i;
    		}
    	}
    }

    if (iswa) {
    	int i = numwa;
    	if (incorrect) {
			quitf(_wa, "Participant's answer for the %d-th query is incorrect: x[%d] = %d .. x[%d] = %d", i + 1, oi[i], oi[i] >= 1 ? x[oi[i]] : -1, oj[i], oj[i] >= 1 ? x[oj[i]] : -1);
    	} else {
			quitf(_wa, "Jury's answer is better for the %d-th query: jury - |(%d)-(%d)|=%d > participant - |(%d)-(%d)|=%d", i + 1, ai[i], aj[i], aj[i] - ai[i], oi[i], oj[i], oj[i] - oi[i]);
    	}
    }

    quitf(_ok, "Output is ok");

    return 0;
}