//#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <sstream>
#include <list>
#include <queue>
#include <deque>
#include <stack>
#include <cstdlib>
#include <cstdio>
#include <iterator>
#include <functional>
#include <bitset>
#define mp make_pair
#define pb push_back

#ifdef LOCAL
#define eprintf(...) fprintf(stderr,__VA_ARGS__)
#else
#define eprintf(...)
#endif

#define TIMESTAMP(x) eprintf("["#x"] Time : %.3lf s.\n", clock()*1.0/CLOCKS_PER_SEC)
#define TIMESTAMPf(x,...) eprintf("[" x "] Time : %.3lf s.\n", __VA_ARGS__, clock()*1.0/CLOCKS_PER_SEC)

#if ( ( _WIN32 || __WIN32__ ) && __cplusplus < 201103L)
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

using namespace std;

#define TASKNAME "A"

#ifdef LOCAL
static struct __timestamper {
  string what;
  __timestamper(const char* what) : what(what){};
  __timestamper(const string& what) : what(what){};
  ~__timestamper(){
        TIMESTAMPf("%s", what.data());
  }
} __TIMESTAMPER("end");
#else 
struct __timestamper {};
#endif

typedef long long ll;
typedef long double ld;

const int MAXN = 200100;
const int BLOCK = 500;

int l[MAXN];
int r[MAXN];
int h[MAXN];
int n, m;

int lans[MAXN];
int rans[MAXN];

inline void relax(int& lans, int& rans, int a, int b) {
  //assert(h[a] < h[b]);
  //assert(a < b);
  if (lans == -1 || (rans - lans < b - a)) {
    lans = a;
    rans = b;
  } 
}

int last1[MAXN];
int next0[MAXN];

int pos[MAXN];
int ansl[BLOCK][BLOCK];
int ansr[BLOCK][BLOCK];
int posh[MAXN];

int main() {
  scanf("%d",&n);
  for (int i = 0; i < n; i++) {
    scanf("%d", &h[i]);
  }

  {
    vector<pair<int, int>> tmp(n);
    for (int i = 0; i < n; i++) {
      tmp[i] = make_pair(h[i], -i);
    }
    sort(tmp.begin(), tmp.end());
    for (int i = 0; i < n; i++) {
      h[-tmp[i].second] = i;
    }
  }

  scanf("%d",&m);
  for (int i = 0; i < m; i++) {
    scanf("%d%d",&l[i], &r[i]);
    --l[i];
  }

  memset(lans, -1, sizeof(lans));
  memset(rans, -1, sizeof(rans));

  TIMESTAMP("read");

  for (int i = BLOCK; i < n; i += BLOCK) {
    last1[0] = -1;
    for (int j = 0; j < n; j++) {
      last1[j + 1] = (h[j] >= i ? j : last1[j]);
    }
    next0[n] = -1;
    for (int j = n - 1; j >= 0; j--) {
      next0[j] = (h[j] < i ? j : next0[j + 1]);
    }

    for (int j = 0; j < m; j++) {
      int a = next0[l[j]];
      int b = last1[r[j]];
      if (a != -1 && b != -1 && a < b) {
        relax(lans[j], rans[j], a, b);
      }
    }
  }

  TIMESTAMP("first");

  for (int lf = 0; lf < n; lf += BLOCK) {
    int rg = min(n, lf + BLOCK);

    int cnt = 0;
    for (int i = 0; i < n; i++) {
      pos[i + 1] = pos[i];
      if (lf <= h[i] && h[i] < rg) {
        posh[cnt++] = i;
        pos[i + 1]++;
      }
    }

    for (int i = 0; i < cnt; i++)
      ansl[i][i] = -1;

    for (int len = 2; len <= cnt; len++) {
      for (int i = 0; i + len <= cnt; i++) {
        int j = i + len - 1;
        ansl[i][j] = -1;
        if (h[posh[i]] < h[posh[j]]) {
          relax(ansl[i][j], ansr[i][j], posh[i], posh[j]);
        }
        if (len > 1 && ansl[i][j-1] != -1) {
          relax(ansl[i][j], ansr[i][j], ansl[i][j-1], ansr[i][j-1]);
        }
        if (len > 1 && ansl[i+1][j] != -1) {
          relax(ansl[i][j], ansr[i][j], ansl[i+1][j], ansr[i+1][j]);
        }
      }
    }

    for (int i = 0; i < m; i++) {
      int posl = pos[l[i]];
      int posr = pos[r[i]] - 1;
      if (posl < posr && ansl[posl][posr] != -1) {
        relax(lans[i], rans[i], ansl[posl][posr], ansr[posl][posr]);
      }
    }    
  }

  TIMESTAMP("second");

  for (int i = 0; i < m; i++) {
    printf("%d %d\n", lans[i] + (lans[i] == -1 ? 0 : 1), rans[i] + (rans[i] == -1 ? 0 : 1));
  }
  return 0;
}
